''  Wii Classic Controller Digital Reader
''  By Jeff Ledger
''  Based on code from Jon McPhalen's Nunchuck reader

CON

  #0, ACK, NAK    

VAR

  byte  raw[6]

  long  scl                                                   
  long  sda
       '
PUB init(sc, sd) 

  scl := sc 
  sda := sd
                                                      
  i2c_start                                                   
  i2c_write($A4)
  i2c_write($F0)
  i2c_write($55)  
  i2c_stop
  i2c_start 
  i2c_write($A4)
  i2c_write($FB)
  i2c_write($00)  
  i2c_stop

  waitcnt(clkfreq / 100 + cnt)                                  

PUB readclassic | idx

  repeat 3                                                     
    i2c_start                                                                                                   
    i2c_write($A4)
    i2c_write($00) 
    i2c_stop
   
  i2c_start                                                    
  i2c_write($A5)                                               
  repeat idx from 0 to 4                                  
    raw[idx] := i2c_read(ACK)                                
  raw[5] := i2c_read(NAK)                                    
  i2c_stop


PUB buttons

  return !((1<<15)|(raw[5]<<7)|(raw[4]>>1)-65536)
 
PUB i2c_wait(id) | ackbit

  repeat 20
    i2c_start
    ackbit := i2c_write(id & $FE)
    if ackbit == ACK
       quit

PUB i2c_start

  dira[sda] := 0                                              
  dira[scl] := 0                                          
  repeat 20
     if (ina[scl] == 0)                             
         quit
  outa[sda] := 0
  dira[sda] := 1                                             

  
PUB i2c_write(i2cbyte) | ackbit

  outa[scl] := 0
  dira[scl] := 1                                             

  i2cbyte <<= constant(32-8)                                   
  repeat 8                                                   
    dira[sda] := ((i2cbyte <-= 1) ^ 1)                       
    dira[scl] := 0                                            
    dira[scl] := 1                                            

  dira[sda] := 0                                               
  dira[scl] := 0                                                 
  ackbit := ina[sda]                                           
  dira[scl] := 1                                              

  return (ackbit & 1)


PUB i2c_read(ackbit) | i2cbyte


  outa[scl] := 0                                              
  dira[sda] := 0                                               

  repeat 8
    dira[scl] := 0                                             
    i2cbyte := (i2cbyte << 1) | ina[sda]                  
    dira[scl] := 1                                           
                             
  dira[sda] := !ackbit                                      
  dira[scl] := 0                                           
  dira[scl] := 1                                                

  return (i2cbyte & $FF)


PUB i2c_stop

  outa[sda] := 0
  dira[sda] := 1                                               
  
  dira[scl] := 0                                           
  repeat 20
    if (ina[scl] == 0)                               
       quit
  dira[sda] := 0                                             

                      
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}