con

   sectorsize = 512
   sectorshift = 9
   dirsize = 32
   dirshift = 5

obj

  sdspi : "sdspifemto"

con

   bootaddr  = sdspi#bootaddr                                                 
   vbase     = sdspi#vbase                                                  

var

 
 
                                       
 
   long fclust                             
   long filesize                                     
   long floc                                
   long frem                                                       
   long bufat                                               
   long bufend                                                           
   long direntry                                                              
   long writelink                                                              
   long fatptr                                                          
   long firstcluster                                 
 
                                                                       
                                                       
 
 
                                      
 
 
                                                                      
                                                                        
                          
 
   byte buf[sectorsize]                   

pub start(iocontrol)

   return sdspi.start(iocontrol)

pub initsdcard(do, clk, di, cs)

   return sdspi.initsdcard(do, clk, di, cs)

pub stopsdcard

   return sdspi.stopsdcard

pub bootsdcard                                                         

   return sdspi.bootsdcard(datablock, filesize <# $8000)

pub readsdcard(address, bufadr, size)

   return sdspi.readsdcard(address, bufadr, size)

pub writesdcard(address, bufadr, size)

   return sdspi.writesdcard(address, bufadr, size)

pub unmount

   return sdspi.stopsdcard

pub out(c)                                                   

   pputc(c)

pub str(stringptr)                                                 

   repeat strsize(stringptr)
      pputc(byte[stringptr++])

pub dec(value) | i                                        

  if value < 0
    -value
    pputc("-")
  i := 1_000_000_000
  repeat 10
    if value => i
      pputc(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      pputc("0")
    i /= 10

pri writeblock2(n, b)

 
                                                                      
                          
 
   sdspi.writesdcard(n, b, sectorsize)
   if (n => fat1)
     if (n < fat1 + sectorsperfat)
       sdspi.writesdcard(n+sectorsperfat, b, sectorsize)

pri flushifdirty

 
                                                 
 
   if (dirty)
      writeblock2(lastread, @buf2)
      dirty := 0

pri readblockc(n)

 
                                                                       
          
 
   if (n <> lastread)
      flushifdirty
      sdspi.readsdcard(n, @buf2, sectorsize)
      lastread := n

pri brword(b)

 
                                                            
 
   return (byte[b]) + ((byte[b][1]) << 8)

pri brlong(b)

 
                                                            
 
   return brword(b) + (brword(b+2) << 16)

pri brclust(b)

 
                         
 
  if (filesystem == 1)
    return brword(b)
  else
    return brlong(b)

pri brwword(w, v)

 
                                                               
                                      
 
   byte[w++] := v
   byte[w] := v >> 8
   dirty := 1

pri brwlong(w, v)

 
                                                               
                                      
 
   brwword(w, v)
   brwword(w+2, v >> 16)

pri brwclust(w, v)

 
                          
   if (filesystem == 1)
     brwword(w, v)
   else
     brwlong(w, v)

pri getfstype : r

   if (brlong(@buf+$36) == constant("F" + ("A" << 8) + ("T" << 16) + ("1" << 24)) and buf[$3a]=="6")
     return 1
   if (brlong(@buf+$52) == constant("F" + ("A" << 8) + ("T" << 16) + ("3" << 24)) and buf[$56]=="2")
     return 2

pub mount(do, clk, di, cs) : r | startblk, sectorspercluster, reserved, rootentries, sectors

                                                                                                                                                                                                            
   if (pdate == 0)
      pdate := constant(((2009-1980) << 25) + (1 << 21) + (27 << 16) + (7 << 11))
   pclose
   unmount
   if initsdcard(do, clk, di, cs)
      abort -string("InitSDCard mount")
   lastread := -1
   dirty := 0
   sdspi.readsdcard(0, @buf, sectorsize)
   if (getfstype > 0)
     startblk := 0
   else
     startblk := brlong(@buf+$1c6)
     sdspi.readsdcard(startblk, @buf, sectorsize)
   filesystem := getfstype
   if (filesystem == 0)
      abort(-20)                              
   if (brword(@buf+$0b) <> sectorsize)
      abort(-21)                       
   sectorspercluster := buf[$0d]
   if (sectorspercluster & (sectorspercluster - 1))
      abort(-22)                          
   clustershift := 0
   repeat while (sectorspercluster > 1)
      clustershift++
      sectorspercluster >>= 1
   sectorspercluster := 1 << clustershift
   clustersize := sectorsize << clustershift
   reserved := brword(@buf+$0e)
   if (buf[$10] <> 2)
      abort(-23)               
   sectors := brword(@buf+$13)
   if (sectors == 0)
     sectors := brlong(@buf+$20)
   fat1 := startblk + reserved
   if (filesystem == 2)
      rootentries := 16 << clustershift
      sectorsperfat := brlong(@buf+$24)
      dataregion := (fat1 + 2 * sectorsperfat) - 2 * sectorspercluster
      rootdir := (dataregion + (brword(@buf+$2c) << clustershift)) << sectorshift
      rootdirend := rootdir + (rootentries << dirshift)
      endofchain := $ffffff0
   else
      rootentries := brword(@buf+$11)
      sectorsperfat := brword(@buf+$16)
      rootdir := (fat1 + 2 * sectorsperfat) << sectorshift
      rootdirend := rootdir + (rootentries << dirshift)
      dataregion := 1 + ((rootdirend - 1) >> sectorshift) - 2 * sectorspercluster
      endofchain := $fff0
   if (brword(@buf+$1fe) <> $aa55)
     abort(-24)                    
   totclusters := ((sectors - dataregion + startblk) >> clustershift)

pri readbytec(byteloc)

 
                                                                     
                                      
 
   readblockc(byteloc >> sectorshift)
   return @buf2 + (byteloc & constant(sectorsize - 1))

pri readfat(clust)

 
                                                                    
          
 
   fatptr := (fat1 << sectorshift) + (clust << filesystem)
   return readbytec(fatptr)

pri followchain : r

 
                                                  
 
   r := brclust(readfat(fclust))
   writelink := fatptr

pri nextcluster : r

 
                                                             
                                                                  
                                                    
 
   r := followchain
   if (r < 2 or r => totclusters)
      abort(-9)                    

pri freeclusters(clust) | bp

 
                                                                   
                                                                     
 
   repeat while (clust < endofchain)
      if (clust < 2)
         abort(-26)                       
      bp := readfat(clust)
      clust := brclust(bp)
      brwclust(bp, 0)
   flushifdirty

pri datablock

 
                                                             
 
   return (fclust << clustershift) + dataregion + ((floc >> sectorshift) & ((1 << clustershift) - 1))

pri uc(c)

 
                                                  
 
   if ("a" =< c and c =< "z")
      return c - 32
   return c

pri pflushbuf(rcnt, metadata) : r | cluststart, newcluster, count, i

 
                                                                 
                                                               
                                                                 
                                                              
 
   if (direntry == 0)
      abort(-27)                       
   if (rcnt > 0)                                                          
      if (frem < sectorsize)
                                                                         
                                               
         newcluster := -1
         cluststart := fclust & (!((sectorsize >> filesystem) - 1))
         count := 2
         repeat
            readfat(cluststart)
            repeat i from 0 to sectorsize - 1<<filesystem step 1<<filesystem
              if (buf2[i] == 0)
                if (brclust(@buf2+i) == 0)
                   newcluster := cluststart + (i >> filesystem)
                   if (newcluster => totclusters)
                      newcluster := -1
                   quit
            if (newcluster > 1)
               brwclust(@buf2+i, endofchain+$f)
               if (writelink == 0)
                  brwword(readbytec(direntry)+$1a, newcluster)
                  writelink := (direntry&(sectorsize-filesystem))
                  brwlong(@buf2+writelink+$1c, floc+bufat)
                  if (filesystem == 2)
                     brwword(@buf2+writelink+$14, newcluster>>16)
               else
                  brwclust(readbytec(writelink), newcluster)
               writelink := fatptr + i
               fclust := newcluster
               frem := clustersize
               quit
            else
               cluststart += (sectorsize >> filesystem)
               if (cluststart => totclusters)
                  cluststart := 0
                  count--
                  if (rcnt < 0)
                     rcnt := -5                          
                     quit
      if (frem => sectorsize)
         sdspi.writesdcard(datablock, @buf, sectorsize)
         if (rcnt == sectorsize)                        
            floc += rcnt
            frem -= rcnt
            bufat := 0
            bufend := rcnt
   if (rcnt < 0 or metadata)                                
      readblockc(direntry >> sectorshift)                            
      brwlong(@buf2+(direntry & (sectorsize-filesystem))+$1c, floc+bufat)
      flushifdirty
   if (rcnt < 0)
      abort(rcnt)
   return rcnt

pub pflush

                                                                                             
   return pflushbuf(bufat, 1)

pri pfillbuf : r

 
                                                                      
                                                                  
           
 
   if (floc => filesize)
      return -1
   if (frem == 0)
      fclust := nextcluster
      frem := (clustersize) <# (filesize - floc)
   sdspi.readsdcard(datablock, @buf, sectorsize)
   r := sectorsize
   if (floc + r => filesize)
      r := filesize - floc
   floc += r
   frem -= r
   bufat := 0
   bufend := r

pub pclose : r

                                                                                                                                               
   if (direntry)
      r := pflush
   bufat := 0
   bufend := 0
   filesize := 0
   floc := 0
   frem := 0
   writelink := 0
   direntry := 0
   fclust := 0
   firstcluster := 0

pub popen(s, mode) : r | i, sentinel, dirptr, freeentry

                                                                                                                                                                                                                                                                                                                                                           
   pclose
   i := 0
   repeat while (i<8 and byte[s] and byte[s] <> ".")
      padname[i++] := uc(byte[s++])
   repeat while (i<8)
      padname[i++] := " "
   repeat while (byte[s] and byte[s] <> ".")
      s++
   if (byte[s] == ".")
      s++
   repeat while (i<11 and byte[s])
      padname[i++] := uc(byte[s++])
   repeat while (i < 11)
      padname[i++] := " "
   sentinel := 0
   freeentry := 0
   repeat dirptr from rootdir to rootdirend - dirsize step dirsize
      s := readbytec(dirptr)
      if (freeentry == 0 and (byte[s] == 0 or byte[s] == $e5))
         freeentry := dirptr
      if (byte[s] == 0)
         sentinel := dirptr
         quit
      repeat i from 0 to 10
         if (padname[i] <> byte[s][i])
            quit
      if (i == 11 and 0 == (byte[s][$0b] & $18))                      
         fclust := brword(s+$1a)
         if (filesystem == 2)
            fclust += brword(s+$14) << 16
         firstcluster := fclust
         filesize := brlong(s+$1c)
         if (mode == "r")
            frem := (clustersize) <# (filesize)
            return 0
         if (byte[s][11] & $d9)
            abort(-6)                         
         if (mode == "d")
            brwword(s, $e5)
            if (fclust)
               freeclusters(fclust)
            flushifdirty
            return 0
         if (mode == "w")
            brwword(s+$1a, 0)
            brwword(s+$14, 0)
            brwlong(s+$1c, 0)
            writelink := 0
            direntry := dirptr
            if (fclust)
               freeclusters(fclust)
            bufend := sectorsize
            fclust := 0
            filesize := 0
            frem := 0
            return 0
         elseif (mode == "a")
                                            
            frem := filesize
            freeentry := clustersize
            if (fclust => endofchain)
               fclust := 0
            repeat while (frem > freeentry)
               if (fclust < 2)
                  abort(-7)                                   
               fclust := nextcluster
               frem -= freeentry
            floc := filesize & constant(!(sectorsize - 1))
            bufend := sectorsize
            bufat := frem & constant(sectorsize - 1)
            writelink := 0
            direntry := dirptr
            if (bufat)
               sdspi.readsdcard(datablock, @buf, sectorsize)
               frem := freeentry - (floc & (freeentry - 1))
            else
               if (fclust < 2 or frem == freeentry)
                  frem := 0
               else
                  frem := freeentry - (floc & (freeentry - 1))
            if (fclust => 2)
               followchain
            return 0
         else
            abort(-3)               
   if (mode <> "w" and mode <> "a")
      return -1            
   direntry := freeentry
   if (direntry == 0)
      abort(-2)                           
                                                        
   s := readbytec(direntry)
   bytefill(s, 0, dirsize)
   bytemove(s, @padname, 11)
   brwword(s+$1a, 0)
   brwword(s+$14, 0)
   i := pdate
   brwlong(s+$e, i)                             
   brwlong(s+$16, i)                                    
   if (direntry == sentinel and direntry + dirsize < rootdirend)
      brwword(readbytec(direntry+dirsize), 0)
   flushifdirty
   writelink := 0
   fclust := 0
   bufend := sectorsize

pub pgetc | t

                                                                                                                                                               
   if (bufat => bufend)
      t := pfillbuf
      if (t =< 0)
         return -1
   return (buf[bufat++])

pub pputc(c) : r

                                                                                                                                        
   if (bufat == sectorsize)
     if (pflushbuf(sectorsize, 0) < 0)
       return -1
   buf[bufat++] := c

pub opendir | off

                                                                                           
   pclose
   off := rootdir - (dataregion << sectorshift)
   fclust := off >> (clustershift + sectorshift)
   floc := off - (fclust << (clustershift + sectorshift))
   frem := rootdirend - rootdir
   filesize := floc + frem
   return 0

pub nextfile(fbuf) | i, t, at, lns

                                                                                                                                                                                                                                                     
   repeat
      if (bufat => bufend)
         t := pfillbuf
         if (t < 0)
            return t
         if (((floc >> sectorshift) & ((1 << clustershift) - 1)) == 0)
            fclust++
      at := @buf + bufat
      if (byte[at] == 0)
         return -1
      bufat += dirsize
      if (byte[at] <> $e5 and (byte[at][$0b] & $18) == 0)
         lns := fbuf
         repeat i from 0 to 10
            byte[fbuf] := byte[at][i]
            fbuf++
            if (byte[at][i] <> " ")
               lns := fbuf
            if (i == 7 or i == 10)
               fbuf := lns
               if (i == 7)
                  byte[fbuf] := "."
                  fbuf++
         byte[fbuf] := 0
         return 0

dat

filesystem  long 0                                      
rootdir  long 0                                                      
rootdirend  long 0                                                     
dataregion  long 0                                                      
clustershift  long 0                                   
clustersize  long 0                                 
fat1  long 0                                      
totclusters  long 0                                  
sectorsperfat  long 0                           
endofchain  long 0                                            
pdate  long 0               
lastread  long 0                                         
dirty  long 0                           
buf2 byte 0[sectorsize]                        
padname byte 0[11]                   
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   